import 'package:car_app/converter/storage_converters/point.dart';
import 'package:car_app/model/point.dart';
import 'package:car_app/model/route.dart';

extension RouteMapConverter on Route {
  static const String teamIdFieldName = "teamId";
  static const String pointsFieldName = "points";

  Map<String, dynamic> toMap() {
    List<Map<String, dynamic>> jsonPoints = [];

    for (var point in points) {
      jsonPoints.add(point.toMap());
    }

    return {
      pointsFieldName: jsonPoints,
      teamIdFieldName: teamId,
    };
  }

  static Route fromMap(Map<String, dynamic> map) {
    return Route(
      teamId: map[teamIdFieldName],
      points: List<Point>.from((List<Map<String, dynamic>>.from(map[pointsFieldName])).map((x) => PointMapConverter.fromMap(x))),
    );
  }
}
