import 'dart:convert';

import 'package:appwrite/appwrite.dart';
import 'package:car_app/converter/appwrite_converters/route.dart';
import 'package:car_app/model/route.dart';
import 'package:car_app/service/appwrite/appwrite.dart';
import 'package:car_app/service/interface/route.dart';

class AppwriteRoute extends RouteService {
  final AppwriteService _appwriteService = AppwriteService();
  final Functions _functions = AppwriteService().functions;
  final String _apiFunctionId = AppwriteService().apiFunctionId;

  Future<Route> add(Route route) async {
    var action = "add route";
    var execution = await _appwriteService.executeFunction(
      _functions.createExecution(functionId: _apiFunctionId, method: "POST", body: jsonEncode(route.toMap()), path: "/route"),
      action,
    );
    
    _appwriteService.throwIfExecutionBodyIsEmpty(execution, action);

    return _appwriteService.fromExecution(execution, RouteMapConverter.fromMap, action);
  }
}
